/***************************************************************************
                          guigettransactions.cpp  -  description
                             -------------------
    begin                : Sa Nov 6 2004
    copyright            : (C) 2004 by Marcel Mulch
    email                : marcel@mulch-online.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "guigettransactions.h"
#include <qcombobox.h>
#include <qstring.h>
#include <qlabel.h>
#include <qbuttongroup.h>
#include <qradiobutton.h>
#include <qpushbutton.h>
#include <qdatetimeedit.h>
#include <qdatetime.h>
#include <qlayout.h>
#include <list>
using namespace std;

#include <openhbci2.h>
#include <openhbci2/date.h>
using namespace HBCI;

/**
*this is the constructor for transactions to transaction list
*
*@param main 
*@param parent the parent dialog of this widget
*@param name widgets title
*@param hobit
*/
GuiGetTransactions::GuiGetTransactions( QWidget *parent, GuiMain* guimain, const char *name, HoBIT* hobit)
:GuiGetTransactionsBase(parent, name) {   
  _hobit = hobit;
  _main = guimain;
  qDebug("Constructor GuiGetTransActions");
}

GuiGetTransactions::~GuiGetTransactions(){
qDebug("Destructor GuiGetTransactions finished");
}


/** 
* look what transactions the user chose for get 
*/
void GuiGetTransactions::accept(){

    Date fromDate, toDate;
    QString accountId = comboBoxAccounts->currentText();
    QDate curdate; curdate = curdate.currentDate();
    toDate = Date(curdate.day(), curdate.month(), curdate.year());
     
     _hobit->createJobGetBalance(); //first get all balances
    
    if (radioButtonDated->isChecked()) {
        QDate fd = dateEditFromDate->date();
        QDate td = dateEditToDate->date();
        fromDate = Date(fd.day(), fd.month(), fd.year());
        toDate = Date(td.day(), td.month(), td.year());
        }
    
    qDebug( "Get transactions from: %s to: %s ", fromDate.toString().c_str(), toDate.toString().c_str());
    
    if (radioButtonAllAccounts->isChecked()) 
        _hobit->createJobGetTransactions(fromDate, toDate, "*");
    else 
        _hobit->createJobGetTransactions(fromDate, toDate, accountId.ascii());
     
    emit raiseWidget(TRANSACTIONS_WIDGET);
    emit sendNow();
 }

 /** Called on show. Sets current account.
 */
 void GuiGetTransactions::showEvent ( QShowEvent * ){
   QDate currentDate; currentDate = currentDate.currentDate();
   QDate lastTransactionDate = _hobit->getLastDateOfTransactions();
   dateEditFromDate->setDate(lastTransactionDate);
   dateEditToDate->setDate(currentDate);
 
   list<Pointer<Account> > accounts = _hobit->listAccounts();
   list<Pointer<Account> >::iterator  accit;
     
   comboBoxAccounts->clear();
   for (accit=accounts.begin(); accit!=accounts.end(); accit++){

          string accountId = (*accit).ref().accountId();
          comboBoxAccounts->insertItem( QString(accountId.c_str()) );
   }

   if (accounts.empty())
           comboBoxAccounts->insertItem(QString(tr("No accounts found")));
   if(lastTransactionDate > currentDate){ //lastTransactionDate may be in the future!! fix it here.
     lastTransactionDate = currentDate; 
     radioButtonUpdate-> setEnabled(false); 
     radioButtonDated->setChecked(true); 
   } 
   else{
     radioButtonUpdate->setEnabled(true); 
     radioButtonUpdate->setChecked(true); 
   }
 }


