/***************************************************************************
 *   Copyright (C) 2004 by Marcel Mulch                                    *
 *   marcel@linux                                                          *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef GUITRANSACTIONINFO_H
#define GUITRANSACTIONINFO_H

#include <guitransactioninfobase.h>
#include <openhbci2/pointer.h>
#include "standingorder.h"
#include "guimain.h"
#include "hobit.h"

class GuiMain;

/**
* This is the form for generating all sorts of transactions. GUI elements, taht are not required for the 
* job executed, are simply hidden.
@author Marcel Mulch
*/
class GuiTransactionInfo : public GuiTransactionInfoBase
{
   Q_OBJECT
public:
    GuiTransactionInfo(QWidget * parent, GuiMain *main, char * name, HoBIT* hobit);
    ~GuiTransactionInfo();
    
    void showStandingOrder(Pointer<StandingOrder> sto);
    void showDatedTransfer(Pointer<DatedTransfer> dt);
    void showTransaction(Pointer<Transaction> tr);
    
    
    /**
      *Set Current used Account to Label in Formular 
      */
	virtual void refresh();
	
	 /**
      *Clears all textfields
      */
	virtual void clearAll();
	
	
     /**
      *Creates Purpose lines
      */
	virtual QString makePurposeString(list<string> purposeLines);
	
	


   /** set hobit object*/
    void setHoBIT(HoBIT* hobit){
     _hobit = hobit;
}
    

public slots:
   void slotBack();
    
signals:
  void goBack();
 
private:
  GuiMain* _main;
  HoBIT* _hobit;
  /** Set from current account, because username is NOT
  *   available from HBCI::Transaction
  */
  QString _OurName;

};

#endif
